/* OS/2 REXX */

/*-----------------------------------------------------
 Parameter 'd' - debug (output loaded task list to log file)
------------------------------------------------------*/

 Signal on halt name finish
 Signal On Novalue

 call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
 Call SysLoadFuncs

 Arg cPar .
 If cPar == 'D' Then lDebug = 1
 Else lDebug = 0

/*------------------------------------------------------*/
 cIni = 'auto.tsk'
 nTimeWait = 15  /* sec */ 
 cLogFile = 'auto'
   /* (MMDD) ᯥ। ᮡ稢    ࠧ */

 /* get current directory */
 curdir = directory()
/*------------------------------------------------------*/
 /* -६ */
 cIniTime = Stream(cIni, 'c', 'query datetime')

 /* 뢠 auto.tsk */
 Call IniRead

 cCurrentLog = cLogFile || SubStr(Date('S'), 3, 4) || '.log'
 Call LineOut cCurrentLog, '///////////////////////// '  ,
                       || Date('E') || ' ' || Time()  ,
                       || ',  ⮬ /////////////////////////'
 Call LineOut cCurrentLog
 Say ' ⮬...'

 'help off'
 'mode 7,1'

 Do Forever

   cDate = Date('S')
   nDay = Date('B') // 7 + 1     /* 1...7 => ... */
   cTime = SubStr(Time(), 1, 5)

   Say ''
   Call CharOut , cTime

   Do i = 1 To aItem.0
     If Pos(nDay, aItem.i.4) = 0 Then NOP 
     Else Do
       If cTime > aItem.i.3 Then NOP  /* 窠 */
       Else Do
         If cTime < aItem.i.3 Then lStatus.i = 1
         Else Do  /*  */
           If lStatus.i = 1 Then Do   /*   ᪨   0 */
             lStatus.i = 0
             Call StartItem i
             Say ''
             Call CharOut , cTime  /*    15 ᥪ ᫥ ᪠ */
           End
         End
       End
     End
   End

   cIniTimeNew = Stream(cIni, 'c', 'query datetime')
   If cIniTimeNew \== cIniTime Then Do
     Call IniRead

     cCurrentLog = cLogFile || SubStr(Date('S'), 3, 4) || '.log'
     Call LineOut cCurrentLog, Date() || ' ' || Time()  ,
                    || ',  ᯨ᪠ '
     Call LineOut cCurrentLog
     cIniTime = cIniTimeNew
     Call CharOut , '*'
   End

   call syssleep nTimeWait

 End
 Signal finish


finish:

 cCurrentLog = cLogFile || SubStr(Date('S'), 3, 4) || '.log'
 Call LineOut cCurrentLog, '\\\\\\\\\\\\\\\\\\\\\\\\\ '  ,
                     || Date('E') || ' ' || Time()  ,
                     || ', 襭 ࠡ \\\\\\\\\\\\\\\\\\\\\\\\\'
 Call LineOut cCurrentLog

 Say '襭 ࠡ...'

 'mode 80,25'

Exit

/*---------------------------------------*/
IniRead:Procedure expose cIni aItem. lStatus. lDebug cLogFile

  Drop aItem.

  lStatus. = 0

  i = 0  

  Do While Lines(cIni) > 0

    cTaskName = LineIn(cIni)
    If SubStr(cTaskName, 1, 1) \== '[' Then Iterate

    i = i + 1
    aItem.i = Translate(cTaskName, '', '[]')   /* [,] away */

    Do Forever
      If Lines(cIni) = 0 Then Leave   /* EOF */
      cTmp = LineIn(cIni)
      If cTmp = '' Then Leave
      If SubStr(cTmp, 1, 1) = ';' Then Iterate /* comment */

      Select
        When Left(cTmp, 9) = 'COMSTRING' Then aItem.i.1 = SubStr(cTmp, 11)
        When Left(cTmp, 8) = 'DIRSTART' Then aItem.i.2 = SubStr(cTmp, 10)
        When Left(cTmp, 9) = 'DAYSSTART' Then aItem.i.4 = SubStr(cTmp, 11)
        /* 12/04/1999 */
        When Left(cTmp, 9) = 'STARTTIME' Then Do
          cTimeStr = SubStr(cTmp, 11)
          Parse Var cTimeStr aItem.i.3 ',' cTimeStr
        End

        OtherWise NOP
      End /* Select */

    End

    /* ᪮쪮 ६ ᪠ १  */
    Do While cTimeStr \= ''
      j = i + 1
      aItem.j = aItem.i
      aItem.j.1 = aItem.i.1
      aItem.j.2 = aItem.i.2
      aItem.j.4 = aItem.i.4
      Parse Var cTimeStr aItem.j.3 ',' cTimeStr
      i = j
    End

  End

  aItem.0 = i

  Call Stream cIni, 'c', 'close'

  cDLogFile = cLogFile || SubStr(Date('S'), 3, 4) || '.log'

  If lDebug Then Do
    Do i = 1 To aItem.0
      Call LineOut cDLogFile, '--------------------------------------'
      Call LineOut cDLogFile, '[' || aItem.i || ']'
      Call LineOut cDLogFile, aItem.i.1
      Call LineOut cDLogFile, aItem.i.2
      Call LineOut cDLogFile, aItem.i.3
      Call LineOut cDLogFile, aItem.i.4
    End
    Call LineOut cDLogFile
  End

Return

/*----------------------------------------*/
StartItem:Procedure expose cIni aItem. cLogFile curdir

 Arg nItem

 cDir = Translate(aItem.nItem.2)
 cName = aItem.nItem

 cCurrentLog = cLogFile || SubStr(Date('S'), 3, 4) || '.log'
 Call LineOut cCurrentLog, Date() || ' ' || Time() || ',  㭪 : ' || aItem.nItem
 Call LineOut cCurrentLog

 If cDir == '.' Then newdir = cDir
 Else Do
   /* go play a game */

   newdir = directory(cDir)
 End

 if newdir = cDir then do
   Interpret aItem.nItem.1

 /* return to former directory */
   If cDir \== '.' Then call directory curdir
 end

 else Do
/*---- say '  ⠫ ' || cDir */
   cCurrentLog = cLogFile || SubStr(Date('S'), 3, 4) || '.log'
   Call LineOut cCurrentLog, '  ⠫ ' || cDir
   Call LineOut cCurrentLog
 End

Return
